'''
Copyright (c) <2015> <Victor de Lorenzo's lab, http://www.cnb.csic.es/~meml/>
                     
Author: Angel Goni-Moreno, www.angelgm.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
'''


import sys
from imageAnalysis import *

try:
    from Tkinter import *
except ImportError:
    from tkinter import *

try:
    import ttk
    py3 = 0
except ImportError:
    import tkinter.ttk as ttk
    py3 = 1

try:
    import tkFileDialog as filedialog
except ImportError:
    import tkinter.filedialog as filedialog

class Std_redirector(object):
    def __init__(self,widget):
        self.widget = widget

    def write(self,string):
         self.widget.insert(END,string)
         self.widget.see(END)
         self.widget.update_idletasks()


def vp_start_gui():
    global val, w, root
    root = Tk()
    root.title('CellShape v0.8')
    geom = "599x732+877+208"
    root.geometry(geom)
    w = Image_Analysis_Tool (root)
    sys.stdout = Std_redirector(w.Text1)
    sys.stderr = Std_redirector(w.Text1)
    root.mainloop()


class Image_Analysis_Tool:
    def __init__(self, master=None):
        _bgcolor = '#d9d9d9'
        _fgcolor = '#000000'
        _compcolor = '#d9d9d9'
        _ana1color = '#d9d9d9'
        _ana2color = '#d9d9d9'
        self.style = ttk.Style()
        if sys.platform == "win32":
            self.style.theme_use('winnative')
        self.style.configure('.',background=_bgcolor)
        self.style.configure('.',foreground=_fgcolor)
        self.style.configure('.',font="TkDefaultFont")
        self.style.map('.',background=
            [('selected', _compcolor), ('active',_ana2color)])
        master.configure(highlightbackground="#b6d9d9")
        master.configure(highlightcolor="black")


        self.Labelframe1 = LabelFrame(master)
        self.Labelframe1.place(relx=0.43, rely=0.4, relheight=0.12
                , relwidth=0.53)
        self.Labelframe1.configure(relief=GROOVE)
        self.Labelframe1.configure(text='''Nucleoid vs. Spots''')
        self.Labelframe1.configure(width=320)

        self.Labelframe4 = LabelFrame(master)
        self.Labelframe4.place(relx=0.43, rely=0.53, relheight=0.12
                , relwidth=0.53)
        self.Labelframe4.configure(relief=GROOVE)
        self.Labelframe4.configure(text='''Cytometry simulation''')
        self.Labelframe4.configure(width=320)

        self.Labelframe2 = LabelFrame(master)
        self.Labelframe2.place(relx=0.43, rely=0.66, relheight=0.12
                , relwidth=0.53)
        self.Labelframe2.configure(relief=GROOVE)
        self.Labelframe2.configure(text='''Correlation of regions''')
        self.Labelframe2.configure(width=320)

        self.Labelframe3 = LabelFrame(master)
        self.Labelframe3.place(relx=0.43, rely=0.79, relheight=0.12
                , relwidth=0.53)
        self.Labelframe3.configure(relief=GROOVE)
        self.Labelframe3.configure(text='''One-image intensity record''')
        self.Labelframe3.configure(width=320)

        self.selectMode = StringVar()

        self.Radiobutton1 = Radiobutton(master, variable=self.selectMode, command=self.select)
        self.Radiobutton1.place(relx=0.38, rely=0.4, relheight=0.03
                , relwidth=0.05)
        self.Radiobutton1.configure(activebackground="#d9d9d9")
        self.Radiobutton1.configure(justify=LEFT)
        self.Radiobutton1.configure(value="NucleoidSpots")

        self.Radiobutton2 = Radiobutton(master, variable=self.selectMode, command=self.select)
        self.Radiobutton2.place(relx=0.38, rely=0.53, relheight=0.03
                , relwidth=0.05)
        self.Radiobutton2.configure(activebackground="#d9d9d9")
        self.Radiobutton2.configure(justify=LEFT)
        self.Radiobutton2.configure(state=ACTIVE)
        self.Radiobutton2.configure(value="PhaseSpots")

        self.Radiobutton3 = Radiobutton(master, variable=self.selectMode, command=self.select)
        self.Radiobutton3.place(relx=0.38, rely=0.66, relheight=0.03
                , relwidth=0.05)
        self.Radiobutton3.configure(activebackground="#d9d9d9")
        self.Radiobutton3.configure(justify=LEFT)
        self.Radiobutton3.configure(value="TwoRegions")

        self.Radiobutton4 = Radiobutton(master, variable=self.selectMode, command=self.select)
        self.Radiobutton4.place(relx=0.38, rely=0.79, relheight=0.03
                , relwidth=0.05)
        self.Radiobutton4.configure(activebackground="#d9d9d9")
        self.Radiobutton4.configure(justify=LEFT)
        self.Radiobutton4.configure(value="OneImage")

        self.Button1 = Button(master, command = lambda: self.openFile('nucleoid'))
        self.Button1.place(relx=0.45, rely=0.43, height=26, width=153)
        self.Button1.configure(activebackground="#d9d9d9")
        self.Button1.configure(text='''Load Nucleoid Image''')

        self.Button2 = Button(master, command = lambda: self.openFile('spots'))
        self.Button2.place(relx=0.72, rely=0.43, height=26, width=135)
        self.Button2.configure(activebackground="#d9d9d9")
        self.Button2.configure(text='''Load Spots Image''')

        self.colourNucleoid = StringVar()
        self.colourSpots = StringVar()
        self.colourRegion1 = StringVar()
        self.colourRegion2 = StringVar()
        self.colourSingle = StringVar()
        self.colourFluo = StringVar()

        self.style.map('TRadiobutton',background=
            [('selected', _bgcolor), ('active',_ana2color)])
        
        self.TRadiobutton1 = ttk.Radiobutton(master, variable=self.colourNucleoid, value='r', command=self.selColourNucleoid)
        self.TRadiobutton1.place(relx=0.48, rely=0.48, relwidth=0.05
                , relheight=0.0, height=19)
        self.TRadiobutton1.configure(takefocus="")
        self.TRadiobutton1.configure(text='''R''')

        self.TRadiobutton2 = ttk.Radiobutton(master, variable=self.colourNucleoid, value='g', command=self.selColourNucleoid)
        self.TRadiobutton2.place(relx=0.54, rely=0.48, relwidth=0.05
                , relheight=0.0, height=19)
        self.TRadiobutton2.configure(takefocus="")
        self.TRadiobutton2.configure(text='''G''')

        self.TRadiobutton3 = ttk.Radiobutton(master, variable=self.colourNucleoid, value='b', command=self.selColourNucleoid)
        self.TRadiobutton3.place(relx=0.61, rely=0.48, relwidth=0.05
                , relheight=0.0, height=19)
        self.TRadiobutton3.configure(takefocus="")
        self.TRadiobutton3.configure(text='''B''')

        self.TRadiobutton4 = ttk.Radiobutton(master, variable=self.colourSpots, value='r', command=self.selColourSpots)
        self.TRadiobutton4.place(relx=0.74, rely=0.48, relwidth=0.05
                , relheight=0.0, height=19)
        self.TRadiobutton4.configure(takefocus="")
        self.TRadiobutton4.configure(text='''R''')

        self.TRadiobutton5 = ttk.Radiobutton(master, variable=self.colourSpots, value='g', command=self.selColourSpots)
        self.TRadiobutton5.place(relx=0.8, rely=0.48, relwidth=0.05
                , relheight=0.0, height=19)
        self.TRadiobutton5.configure(takefocus="")
        self.TRadiobutton5.configure(text='''G''')

        self.TRadiobutton6 = ttk.Radiobutton(master, variable=self.colourSpots, value='b', command=self.selColourSpots)
        self.TRadiobutton6.place(relx=0.87, rely=0.48, relwidth=0.05
                , relheight=0.0, height=19)
        self.TRadiobutton6.configure(takefocus="")
        self.TRadiobutton6.configure(text='''B''')

        self.Button3 = Button(master, command = lambda: self.openFile('phase'))
        self.Button3.place(relx=0.45, rely=0.56, height=26, width=153)
        self.Button3.configure(activebackground="#d9d9d9")
        self.Button3.configure(text='''Load PH Image''')

        self.Button4 = Button(master, command = lambda: self.openFile('fluorescent'))
        self.Button4.place(relx=0.72, rely=0.56, height=26, width=135)
        self.Button4.configure(activebackground="#d9d9d9")
        self.Button4.configure(text='''Load Fluo. Image''')

        self.TRadiobutton7 = ttk.Radiobutton(master, variable=self.colourFluo, value='r', command=self.selColourFluo)
        self.TRadiobutton7.place(relx=0.74, rely=0.61, relwidth=0.05
                , relheight=0.0, height=19)
        self.TRadiobutton7.configure(takefocus="")
        self.TRadiobutton7.configure(text='''R''')

        self.TRadiobutton8 = ttk.Radiobutton(master, variable=self.colourFluo, value='g', command=self.selColourFluo)
        self.TRadiobutton8.place(relx=0.8, rely=0.61, relwidth=0.05
                , relheight=0.0, height=19)
        self.TRadiobutton8.configure(takefocus="")
        self.TRadiobutton8.configure(text='''G''')

        self.TRadiobutton9 = ttk.Radiobutton(master, variable=self.colourFluo, value='b', command=self.selColourFluo)
        self.TRadiobutton9.place(relx=0.86, rely=0.61, relwidth=0.05
                , relheight=0.0, height=19)
        self.TRadiobutton9.configure(takefocus="")
        self.TRadiobutton9.configure(text='''B''')

        self.Button5 = Button(master, command = lambda: self.openFile('region1'))
        self.Button5.place(relx=0.45, rely=0.69, height=26, width=140)
        self.Button5.configure(activebackground="#d9d9d9")
        self.Button5.configure(text='''Load Reg.#1 Image''')

        self.Text1 = Text(master)
        self.Text1.place(relx=0.03, rely=0.05, relheight=0.32, relwidth=0.93)
        self.Text1.configure(background="white")
        self.Text1.configure(font="TkTextFont")
        self.Text1.configure(selectbackground="#c4c4c4")
        self.Text1.configure(width=556)
        self.Text1.configure(wrap=WORD)
        
        self.Button6 = Button(master, command = lambda: self.openFile('region2'))
        self.Button6.place(relx=0.7, rely=0.69, height=26, width=140)
        self.Button6.configure(activebackground="#d9d9d9")
        self.Button6.configure(text='''Load Reg.#2 Image''')

        self.TRadiobutton10 = ttk.Radiobutton(master, variable=self.colourRegion1, value='r', command=self.selColourRegion1)
        self.TRadiobutton10.place(relx=0.48, rely=0.74, relwidth=0.05
                , relheight=0.0, height=19)
        self.TRadiobutton10.configure(takefocus="")
        self.TRadiobutton10.configure(text='''R''')

        self.TRadiobutton11 = ttk.Radiobutton(master, variable=self.colourRegion1, value='g', command=self.selColourRegion1)
        self.TRadiobutton11.place(relx=0.54, rely=0.74, relwidth=0.05
                , relheight=0.0, height=19)
        self.TRadiobutton11.configure(takefocus="")
        self.TRadiobutton11.configure(text='''G''')

        self.TRadiobutton12 = ttk.Radiobutton(master, variable=self.colourRegion1, value='b', command=self.selColourRegion1)
        self.TRadiobutton12.place(relx=0.61, rely=0.74, relwidth=0.05
                , relheight=0.0, height=19)
        self.TRadiobutton12.configure(takefocus="")
        self.TRadiobutton12.configure(text='''B''')

        self.TRadiobutton13 = ttk.Radiobutton(master, variable=self.colourRegion2, value='r', command=self.selColourRegion2)
        self.TRadiobutton13.place(relx=0.73, rely=0.74, relwidth=0.05
                , relheight=0.0, height=19)
        self.TRadiobutton13.configure(takefocus="")
        self.TRadiobutton13.configure(text='''R''')

        self.TRadiobutton14 = ttk.Radiobutton(master, variable=self.colourRegion2, value='g', command=self.selColourRegion2)
        self.TRadiobutton14.place(relx=0.79, rely=0.74, relwidth=0.05
                , relheight=0.0, height=19)
        self.TRadiobutton14.configure(takefocus="")
        self.TRadiobutton14.configure(text='''G''')

        self.TRadiobutton15 = ttk.Radiobutton(master, variable=self.colourRegion2, value='b', command=self.selColourRegion2)
        self.TRadiobutton15.place(relx=0.86, rely=0.74, relwidth=0.05
                , relheight=0.0, height=19)
        self.TRadiobutton15.configure(takefocus="")
        self.TRadiobutton15.configure(text='''B''')

        self.Button7 = Button(master, command = lambda: self.openFile('single'))
        self.Button7.place(relx=0.6, rely=0.83, height=26, width=121)
        self.Button7.configure(activebackground="#d9d9d9")
        self.Button7.configure(text='''Load Image File''')

        self.TRadiobutton16 = ttk.Radiobutton(master, variable=self.colourSingle, value='r', command=self.selColourSingle)
        self.TRadiobutton16.place(relx=0.62, rely=0.87, relwidth=0.05
                , relheight=0.0, height=19)
        self.TRadiobutton16.configure(takefocus="")
        self.TRadiobutton16.configure(text='''R''')

        self.TRadiobutton17 = ttk.Radiobutton(master, variable=self.colourSingle, value='g', command=self.selColourSingle)
        self.TRadiobutton17.place(relx=0.68, rely=0.87, relwidth=0.05
                , relheight=0.0, height=19)
        self.TRadiobutton17.configure(takefocus="")
        self.TRadiobutton17.configure(text='''G''')

        self.TRadiobutton18 = ttk.Radiobutton(master, variable=self.colourSingle, value='b', command=self.selColourSingle)
        self.TRadiobutton18.place(relx=0.74, rely=0.87, relwidth=0.05
                , relheight=0.0, height=19)
        self.TRadiobutton18.configure(takefocus="")
        self.TRadiobutton18.configure(text='''B''')

        self.Labelframe5 = LabelFrame(master)
        self.Labelframe5.place(relx=0.03, rely=0.4, relheight=0.51
                , relwidth=0.33)
        self.Labelframe5.configure(relief=GROOVE)
        self.Labelframe5.configure(text='''Variables''')
        self.Labelframe5.configure(width=200)

        self.Label1 = Label(self.Labelframe5)
        self.Label1.place(relx=0.05, rely=0.18, height=18, width=66)
        self.Label1.configure(text='''Level lines''')

        self.Label2 = Label(self.Labelframe5)
        self.Label2.place(relx=0.05, rely=0.25, height=18, width=93)
        self.Label2.configure(text='''min inner level''')

        self.Label3 = Label(self.Labelframe5)
        self.Label3.place(relx=0.05, rely=0.31, height=18, width=93)
        self.Label3.configure(text='''max inner evel''')

        self.Label4 = Label(self.Labelframe5)
        self.Label4.place(relx=0.05, rely=0.38, height=18, width=94)
        self.Label4.configure(text='''min outer level''')

        self.Label5 = Label(self.Labelframe5)
        self.Label5.place(relx=0.05, rely=0.44, height=18, width=97)
        self.Label5.configure(text='''max outer level''')

        self.Label6 = Label(self.Labelframe5)
        self.Label6.place(relx=0.05, rely=0.61, height=18, width=66)
        self.Label6.configure(text='''Level lines''')

        self.Label7 = Label(self.Labelframe5)
        self.Label7.place(relx=0.05, rely=0.68, height=18, width=58)
        self.Label7.configure(text='''min level''')

        self.Label8 = Label(self.Labelframe5)
        self.Label8.place(relx=0.05, rely=0.74, height=18, width=61)
        self.Label8.configure(text='''max level''')

        self.Message2 = Message(self.Labelframe5)
        self.Message2.place(relx=0.05, rely=0.08, relheight=0.05, relwidth=0.92)
        self.Message2.configure(relief=SUNKEN)
        self.Message2.configure(text='''Shape recognition:''')
        self.Message2.configure(width=183)

        self.Message3 = Message(self.Labelframe5)
        self.Message3.place(relx=0.05, rely=0.53, relheight=0.05, relwidth=0.9)
        self.Message3.configure(relief=SUNKEN)
        self.Message3.configure(text='''Spot recognition:''')
        self.Message3.configure(width=180)

        self.contoursNucleoid = Entry(self.Labelframe5)
        self.contoursNucleoid.place(relx=0.8, rely=0.17, relheight=0.05, relwidth=0.13)
        self.contoursNucleoid.configure(background="white")
        self.contoursNucleoid.configure(font="TkFixedFont")
        self.contoursNucleoid.insert(0, "10")
        self.contoursNucleoid.configure(width=26)

        self.minNucleoid = Entry(self.Labelframe5)
        self.minNucleoid.place(relx=0.8, rely=0.24, relheight=0.05, relwidth=0.13)
        self.minNucleoid.configure(background="white")
        self.minNucleoid.configure(font="TkFixedFont")
        self.minNucleoid.insert(0, "3")
        self.minNucleoid.configure(width=26)

        self.maxNucleoid = Entry(self.Labelframe5)
        self.maxNucleoid.place(relx=0.8, rely=0.31, relheight=0.05, relwidth=0.13)
        self.maxNucleoid.configure(background="white")
        self.maxNucleoid.configure(font="TkFixedFont")
        self.maxNucleoid.insert(0, "5")
        self.maxNucleoid.configure(width=26)

        self.minExtended = Entry(self.Labelframe5)
        self.minExtended.place(relx=0.8, rely=0.38, relheight=0.05, relwidth=0.13)
        self.minExtended.configure(background="white")
        self.minExtended.configure(font="TkFixedFont")
        self.minExtended.insert(0, "1")
        self.minExtended.configure(width=26)

        self.maxExtended = Entry(self.Labelframe5)
        self.maxExtended.place(relx=0.8, rely=0.44, relheight=0.05, relwidth=0.13)
        self.maxExtended.configure(background="white")
        self.maxExtended.configure(font="TkFixedFont")
        self.maxExtended.insert(0, "2")
        self.maxExtended.configure(width=26)

        self.contoursSpots = Entry(self.Labelframe5)
        self.contoursSpots.place(relx=0.8, rely=0.61, relheight=0.05, relwidth=0.13)
        self.contoursSpots.configure(background="white")
        self.contoursSpots.configure(font="TkFixedFont")
        self.contoursSpots.insert(0, "10")
        self.contoursSpots.configure(width=26)

        self.minSpots = Entry(self.Labelframe5)
        self.minSpots.place(relx=0.8, rely=0.67, relheight=0.05, relwidth=0.13)
        self.minSpots.configure(background="white")
        self.minSpots.configure(font="TkFixedFont")
        self.minSpots.insert(0, "1")
        self.minSpots.configure(width=26)

        self.maxSpots = Entry(self.Labelframe5)
        self.maxSpots.place(relx=0.8, rely=0.74, relheight=0.05, relwidth=0.13)
        self.maxSpots.configure(background="white")
        self.maxSpots.configure(font="TkFixedFont")
        self.maxSpots.insert(0, "8")
        self.maxSpots.configure(width=26)

        self.Message4 = Message(self.Labelframe5)
        self.Message4.place(relx=0.05, rely=0.83, relheight=0.05, relwidth=0.91)
        self.Message4.configure(relief=SUNKEN)
        self.Message4.configure(text='''Correlation:''')
        self.Message4.configure(width=181)

        self.Label9 = Label(self.Labelframe5)
        self.Label9.place(relx=0.05, rely=0.91, height=18, width=66)
        self.Label9.configure(text='''Level lines''')

        self.Entry9 = Entry(self.Labelframe5)
        self.Entry9.place(relx=0.8, rely=0.91, relheight=0.05, relwidth=0.13)
        self.Entry9.configure(background="white")
        self.Entry9.configure(font="TkFixedFont")
        self.Entry9.insert(0, "10")
        self.Entry9.configure(width=26)

        self.Message1 = Message(master)
        self.Message1.place(relx=0.08, rely=0.01, relheight=0.04, relwidth=0.84)
        self.Message1.configure(foreground="#717171")
        self.Message1.configure(justify=CENTER)
        self.Message1.configure(text='''CellShape: an image analysis tool for bacterial fluorescent microscopy. Beta version released by agoni@cnb.csic.es''')
        self.Message1.configure(width=503)

        self.Button8 = Button(master)
        self.Button8.place(relx=0.15, rely=0.93, height=30, width=160)
        self.Button8.configure(activebackground="#d9d9d9")
        self.Button8.configure(text='''Begin Analysis''')
        self.Button8.configure(width=160)
        self.Button8.bind("<ButtonRelease-1>", self.beginAnalysis)

        self.Button9 = Button(master)
        self.Button9.place(relx=0.55, rely=0.93, height=30, width=160)
        self.Button9.configure(activebackground="#d9d9d9")
        self.Button9.configure(text='''Plot Results''')
        self.Button9.bind("<ButtonRelease-1>", self.plotResults)

        self.box_value = StringVar()
        self.TCombobox1 = ttk.Combobox(master)
        self.TCombobox1.bind('<<ComboboxSelected>>', self.change_value)
        self.TCombobox1.place(relx=0.17, rely=0.4, relheight=0.02, relwidth=0.08)
        self.TCombobox1.configure(textvariable=self.box_value)
        self.TCombobox1.configure(values=("fast", "deep", "phase"))
        self.TCombobox1.current(0)
        self.TCombobox1.configure(width=47)
        self.TCombobox1.configure(takefocus="")

    def change_value(self,event):
        if self.TCombobox1.current() == 0:
            self.contoursNucleoid.delete(0, 'end')
            self.minNucleoid.delete(0, 'end')
            self.maxNucleoid.delete(0, 'end')
            self.minExtended.delete(0, 'end')
            self.maxExtended.delete(0, 'end')
            self.contoursSpots.delete(0, 'end')
            self.minSpots.delete(0, 'end')
            self.maxSpots.delete(0, 'end')
            self.Entry9.delete(0, 'end')
            self.contoursNucleoid.insert(0, "10")
            self.minNucleoid.insert(0, "3")
            self.maxNucleoid.insert(0, "5")
            self.minExtended.insert(0, "1")
            self.maxExtended.insert(0, "2")
            self.contoursSpots.insert(0, "10")
            self.minSpots.insert(0, "1")
            self.maxSpots.insert(0, "8")
            self.Entry9.insert(0, "10")
        elif self.TCombobox1.current() == 1:
            self.contoursNucleoid.delete(0, 'end')
            self.minNucleoid.delete(0, 'end')
            self.maxNucleoid.delete(0, 'end')
            self.minExtended.delete(0, 'end')
            self.maxExtended.delete(0, 'end')
            self.contoursSpots.delete(0, 'end')
            self.minSpots.delete(0, 'end')
            self.maxSpots.delete(0, 'end')
            self.Entry9.delete(0, 'end')
            self.contoursNucleoid.insert(0, "50")
            self.minNucleoid.insert(0, "17")
            self.maxNucleoid.insert(0, "25")
            self.minExtended.insert(0, "7")
            self.maxExtended.insert(0, "15")
            self.contoursSpots.insert(0, "50")
            self.minSpots.insert(0, "10")
            self.maxSpots.insert(0, "45")
            self.Entry9.insert(0, "10")
        else:
            self.contoursNucleoid.delete(0, 'end')
            self.minNucleoid.delete(0, 'end')
            self.maxNucleoid.delete(0, 'end')
            self.minExtended.delete(0, 'end')
            self.maxExtended.delete(0, 'end')
            self.contoursSpots.delete(0, 'end')
            self.minSpots.delete(0, 'end')
            self.maxSpots.delete(0, 'end')
            self.Entry9.delete(0, 'end')
            self.contoursNucleoid.insert(0, "50")
            self.minNucleoid.insert(0, "30")
            self.maxNucleoid.insert(0, "37")
            self.minExtended.insert(0, "18")
            self.maxExtended.insert(0, "24")
            self.contoursSpots.insert(0, "50")
            self.minSpots.insert(0, "10")
            self.maxSpots.insert(0, "45")
            self.Entry9.insert(0, "10")

    def beginAnalysis(self, event):
        if self.selectMode.get() == "NucleoidSpots":
            iAnalysis(self)
        elif self.selectMode.get() == "PhaseSpots":
            iCytometryEmulator(self)
        elif self.selectMode.get() == "TwoRegions":
            iTwoRegions(self)
        elif self.selectMode.get() == "OneImage":
            iOneImage(self)

    def plotResults(self, event):
        plotData()

    def openFile(self,name):
        filename = filedialog.askopenfilename()
        if filename == '':
            sys.stdout.write('Warning! No image selected \n\n')
        else:
            if name == 'nucleoid':
                self.nucleoidFile = filename
                sys.stdout.write('Nucleoid image selected at: \n' + str(filename) + '\n\n')
            elif name == 'spots':
                self.spotsFile = filename
                sys.stdout.write('Spots image selected at: \n' + str(filename) + '\n\n')
            elif name == 'phase':
                self.phaseFile = filename
                sys.stdout.write('Phase contrast image selected at: \n' + str(filename) + '\n\n')
            elif name == 'region1':
                self.region1File = filename
                sys.stdout.write('Region #1 image selected at: \n' + str(filename) + '\n\n')
            elif name == 'region2':
                self.region2File = filename
                sys.stdout.write('Region #2 image selected at: \n' + str(filename) + '\n\n')
            elif name == 'single':
                self.singleFile = filename
                sys.stdout.write('Single image selected at: \n' + str(filename) + '\n\n')
            elif name == 'fluorescent':
                self.fluoFile = filename
                sys.stdout.write('Fluorescence image selected at : \n' + str(filename) + '\n\n')

    def select(self):
        return self.selectMode.get()

    def selectCN(self):
        self.colourNucleoid = 'd'

    def selColourNucleoid(self):
        return self.colourNucleoid.get()
    def selColourSpots(self):
        return self.colourSpots.get()
    def selColourRegion1(self):
        return self.colourRegion1.get()
    def selColourRegion2(self):
        return self.colourRegion2.get()
    def selColourSingle(self):
        return self.colourSingle.get()
    def selColourFluo(self):
        return self.colourFluo.get()


if __name__ == '__main__':
    vp_start_gui()



