'''
Copyright (c) <2015> <Victor de Lorenzo's lab, http://www.cnb.csic.es/~meml/>
                     
Author: Angel Goni-Moreno, www.angelgm.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
'''

from packages import *
from report import *

def plotNucleoidLines(shapes,fig,self):
    n = 1
    beginBar(self)
    for shape in shapes:
        x, y = shape.exterior.coords.xy
        fig.gca().plot(x, y,'w',lw=2)
        if len(shapes)<40:
            updateBar(self)
        else:
            if n%(len(shapes)/40)== 0: updateBar(self)
        n+=1
    im = plt.imread(self.nucleoidFile)
    implot = fig.gca().imshow(im)
    endBar(self)

def plotNucleoidLinesWhiteBack(shapes,fig,self):
    n = 1
    beginBar(self)
    for shape in shapes:
        x, y = shape.exterior.coords.xy
        fig.gca().plot(x, y,'k',lw=2)
        if len(shapes)<40:
            updateBar(self)
        else:
            if n%(len(shapes)/40)== 0: updateBar(self)
        n+=1
    endBar(self)

def plotPhase(shapes,fig,self):
    n = 1
    beginBar(self)
    for shape in shapes:
        x, y = shape.exterior.coords.xy
        fig.gca().plot(x, y,lw=2)
        if len(shapes)<40:
            updateBar(self)
        else:
            if n%(len(shapes)/40)== 0: updateBar(self)
        n+=1
    im = plt.imread(self.phaseFile)
    implot = fig.gca().imshow(im)
    endBar(self)
    writeReport("    Total number of cells in figure: " + str(len(shapes)) + '\n\n',self)

def plotExtendedLines(shapes,fig,self):
    n = 1
    beginBar(self)
    for shape in shapes:
        x, y = shape.exterior.coords.xy
        fig.gca().plot(x, y,'y',lw=2)
        if len(shapes)<40:
            updateBar(self)
        else:
            if n%(len(shapes)/40)== 0: updateBar(self)
        n+=1
    im = plt.imread(self.nucleoidFile)
    implot = fig.gca().imshow(im)
    endBar(self)

def plotExtendedLinesWhiteBack(shapes,fig,self):
    n = 1
    beginBar(self)
    for shape in shapes:
        x, y = shape.exterior.coords.xy
        fig.gca().plot(x, y,'y',lw=2)
        if len(shapes)<40:
            updateBar(self)
        else:
            if n%(len(shapes)/40)== 0: updateBar(self)
        n+=1
    endBar(self)

def plotPoints(shapes,fig,self):
    n = 0
    beginBar(self)
    for shape in shapes:
        x = shape.centroid.x
        y = shape.centroid.y
        fig.gca().plot(x,y,'wo')
        if len(shapes)<40:
            updateBar(self)
        else:
            if n%(len(shapes)/40)== 0: updateBar(self)
        n+=1
    im = plt.imread(self.spotsFile)
    implot = fig.gca().imshow(im)
    endBar(self)

def plotPointsWhiteBack(shapes,fig,self):
    n = 0
    beginBar(self)
    for shape in shapes:
        x = shape.centroid.x
        y = shape.centroid.y
        fig.gca().plot(x,y,'ro')
        if len(shapes)<40:
            updateBar(self)
        else:
            if n%(len(shapes)/40)== 0: updateBar(self)
        n+=1
    endBar(self)

def plotIntensityStats(emptyShapesPoints, emptyShapesInner, emptyShapesOuter,self):
# input 'fig' removed

    def plotPointsInsideShape(points, shapes):
        Points = []
        xPoints = []
        yPoints = []
        remove = []
        for point in points:
            if shapes != []:
                center = point[0].centroid
                for shape in shapes:
                    if center.within(shape):
                        Points.append(point[1])   
                        remove.append(point)         
                        break
            if shapes == []:
                Points.append(point[1])
        x = list(set(Points))
        for i in x:
            xPoints.append(i)
            yPoints.append(Points.count(i))
        if yPoints != []:
           max_yPoints = max(yPoints)
           yPoints = [i/float(max_yPoints) for i in yPoints]
        else:
           yPoints = []
        if xPoints != []:
           max_xPoints = max(xPoints)
           xPoints = [i/float(max_xPoints) for i in xPoints]
        else:
           xPoints = []
        #fig.gca().plot(xPoints,yPoints,'-')
        return remove

    def removeFromList(points, remove):
        pointsNew = []
        for point in points:
            if point not in remove:
                pointsNew.append(point)
        return pointsNew
   
    writeReport("    Total number of spots in figure: " + str(len(emptyShapesPoints)) + '\n',self)
    writeReport("    Total number of nucleoid regions in figure: " + str(len(emptyShapesInner)) + '\n',self)
    writeReport("    Total number of extended regions in figure: " + str(len(emptyShapesOuter)) + '\n',self)
    rem = plotPointsInsideShape(emptyShapesPoints, emptyShapesInner)
    writeReport("    Number of spots in nucleoid regions: " + str(len(rem)) + '\n',self)
    new = removeFromList(emptyShapesPoints, rem)
    rem2 = plotPointsInsideShape(new, emptyShapesOuter)
    writeReport("    Number of spots in extended regions: " + str(len(rem2)) + '\n',self)
    new2 = removeFromList(new,rem2)
    rem3 = plotPointsInsideShape(new2, [])

def plotPixelView(Analysis,fig,color,self):
    if color == "r":
        fig.colorbar(fig.gca().imshow(Analysis[2], cmap=cm.Reds, interpolation='nearest'))
    elif color == "g":
        fig.colorbar(fig.gca().imshow(Analysis[2], cmap=cm.Greens, interpolation='nearest'))
    else:
        fig.colorbar(fig.gca().imshow(Analysis[2], cmap=cm.Blues, interpolation='nearest'))

def plotContourView(Analysis,fig,color,self):
    levels = [0, 0.2, 0.4, 0.6, 0.8, 1]
    if color == "r":
        fig.colorbar(fig.gca().contourf(Analysis[0],Analysis[1],Analysis[2],levels,cmap=cm.Reds))
    elif color == "g":
        fig.colorbar(fig.gca().contourf(Analysis[0],Analysis[1],Analysis[2],levels,cmap=cm.Greens))
    else:
        fig.colorbar(fig.gca().contourf(Analysis[0],Analysis[1],Analysis[2],levels,cmap=cm.Blues))

def plotMatchContours(Analysis1, Analysis2, fig, color1, color2, self):
    if color1 == "r":
        fig.gca().contour(Analysis1[0],Analysis1[1],Analysis1[2],cmap=cm.Reds)
    elif color1 == "g":
        fig.gca().contour(Analysis1[0],Analysis1[1],Analysis1[2],cmap=cm.Greens)
    else:
        fig.gca().contour(Analysis1[0],Analysis1[1],Analysis1[2],cmap=cm.Blues)
    if color2 == "r":
        fig.gca().contour(Analysis2[0],Analysis2[1],Analysis2[2],cmap=cm.Reds)
    elif color2 == "g":
        fig.gca().contour(Analysis2[0],Analysis2[1],Analysis2[2],cmap=cm.Greens)
    else:
        fig.gca().contour(Analysis2[0],Analysis2[1],Analysis2[2],cmap=cm.Blues)

def plot3DView(Analysis,fig, color, self):
    if color == "r":
        fig.gca(projection='3d').plot_wireframe(Analysis[0],Analysis[1],Analysis[2],rstride=3, cstride=3, cmap='Greens', lw=1, color="r")
    elif color == "g":
        fig.gca(projection='3d').plot_wireframe(Analysis[0],Analysis[1],Analysis[2],rstride=3, cstride=3, cmap='Greens', lw=1, color="g")
    else:
        fig.gca(projection='3d').plot_wireframe(Analysis[0],Analysis[1],Analysis[2],rstride=3, cstride=3, cmap='Greens', lw=1, color="b")
    
def plotCytometry(shapes_values,fig,self,*rest):
    values = []
    for shape in shapes_values:
        try:
            x = shape[0].centroid.x
            y = shape[0].centroid.y 
            values.append(shape[1])
        except AttributeError:
            pass
    cytometry_x = []
    cytometry_y = []
    if list(rest) == []:
        size_interval =  int(max(values)/500.0)
    else:
        size_interval =  1
    min_interval = 0
    while min_interval <= max(values):
        counts = 0
        cytometry_x.append(min_interval)
        for i in range(size_interval):
            counts += values.count(min_interval+i)
        cytometry_y.append(counts)
        min_interval += size_interval
        if list(rest) != []:
            size_interval = size_interval + int((size_interval/2.0)+1)#* 2
    fig.gca().plot(cytometry_x,cytometry_y)
    fig.gca().axis('auto')
    fig.gca().set_ylim([0,max(cytometry_y)])
    if list(rest) != []:
        fig.gca().set_xscale('log')

def plotCytometryMap(shapes_values,fig,self):

    for shape in shapes_values:
        try:
            x = shape[0].centroid.x
            y = shape[0].centroid.y
            fig.gca().annotate(str(shape[1]),xy=(0,0), xytext=(x, y), color='r')     
        except AttributeError:
            pass
    im = plt.imread(self.fluoFile)
    implot = fig.gca().imshow(im)








